'$INCLUDE: 'lib\fmslib.bi'

DEFINT A-Z
SUB initfms
FOR i = 0 TO 224
  SetReg i, 0 'Clear all registers
NEXT i
SetReg &H20, &H2 'Plays carrier note at specified octave ch. 1
SetReg &H23, &H2 'Plays modulator note at specified octave ch. 1
SetReg &H40, &H1F 'Set carrier total level to softest ch. 1
SetReg &H43, &H0 'Set modulator level to loudest ch. 1
SetReg &H60, &HE4 'Set carrier attack and decay ch. 1
SetReg &H63, &HE4 'Set modulator attack and decay ch. 1
SetReg &H80, &H9D 'Set carrier sustain and release ch. 1
SetReg &H83, &H9D 'Set modulator sustain and release ch. 1

SetReg &H21, &H2 'Plays carrier note at specified octave ch. 2
SetReg &H24, &H2 'Plays modulator note at specified octave ch. 2
SetReg &H41, &H1F 'Set carrier total level to softest ch. 2
SetReg &H44, &H0 'Set modulator level to loudest ch. 2
SetReg &H61, &HE4 'Set carrier attack and decay ch. 2
SetReg &H64, &HE4 'Set modulator attack and decay ch. 2
SetReg &H81, &H9D 'Set carrier sustain and release ch. 2
SetReg &H84, &H9D 'Set modulator sustain and release ch. 2

SetReg &H22, &H2 'Plays carrier note at specified octave ch. 3
SetReg &H25, &H2 'Plays modulator note at specified octave ch. 3
SetReg &H42, &H1F 'Set carrier total level to softest ch. 3
SetReg &H45, &H0 'Set modulator level to loudest ch. 3
SetReg &H62, &HE4 'Set carrier attack and decay ch. 3
SetReg &H65, &HE4 'Set modulator attack and decay ch. 3
SetReg &H82, &H9D 'Set carrier sustain and release ch. 3
SetReg &H85, &H9D 'Set modulator sustain and release ch. 3


END SUB

DEFSNG A-Z
SUB Manage.Note (NoteTime!, NoteDur!)
        IF NoteTime! + NoteDur! < TIMER THEN
                NoteTime! = 0
                Stop.Sound
        END IF
END SUB

DEFINT A-Z
SUB playnote (notes() AS STRING, octaves() AS INTEGER, duration!, tempo%, count AS INTEGER)
'octa$ = "O" + LTRIM$(RTRIM$(STR$(octaves(count - 1))))
'nota$ = notes(count - 1)
'IF MID$(nota$, 2, 1) = "#" THEN MID$(nota$, 2, 1) = "+"
'IF LCASE$(MID$(nota$, 2, 1)) = "b" THEN MID$(nota$, 2, 1) = "-"
'lengt = 4 * (1 / duration!)
'leng$ = "L" + LTRIM$(RTRIM$(STR$(lengt)))
'tempi$ = "T" + LTRIM$(RTRIM$(STR$(tempo%)))
'PLAY tempi$
'PLAY octa$
'PLAY leng$
'PLAY nota$
'EXIT SUB

        FOR chanel = 0 TO count - 1
                  note$ = notes(chanel + 1)
                  octave = octaves(chanel + 1)
                SELECT CASE UCASE$(LTRIM$(RTRIM$(note$)))
                        CASE "C#"
                                SetReg &HA0 + chanel, &H6B 'Set note number
                                SetReg &HB0 + chanel, &H21 + 4 * octave 'Set octave and switch on channel
                        CASE "DB"
                                SetReg &HA0 + chanel, &H6B 'Set note number
                                SetReg &HB0 + chanel, &H21 + 4 * octave 'Set octave and switch on channel
                        CASE "D"
                                SetReg &HA0 + chanel, &H81
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "D#"
                                SetReg &HA0 + chanel, &H98
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "EB"
                                SetReg &HA0 + chanel, &H98
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "E"
                                SetReg &HA0 + chanel, &HB0
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "F"
                                SetReg &HA0 + chanel, &HCA
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "F#"
                                SetReg &HA0 + chanel, &HE5
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "GB"
                                SetReg &HA0 + chanel, &HE5
                                SetReg &HB0 + chanel, &H21 + 4 * octave
                        CASE "G"
                                SetReg &HA0 + chanel, &H2
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "G#"
                                SetReg &HA0 + chanel, &H20
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "AB"
                                SetReg &HA0 + chanel, &H20
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "A"
                                SetReg &HA0 + chanel, &H41
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "A#"
                                SetReg &HA0 + chanel, &H63
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "BB"
                                SetReg &HA0 + chanel, &H63
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "B"
                                SetReg &HA0 + chanel, &H87
                                SetReg &HB0 + chanel, &H22 + 4 * octave
                        CASE "C"
                                SetReg &HA0 + chanel, &HAE
                                SetReg &HB0 + chanel, &H22 + 4 * (octave - 1)
                END SELECT
        NEXT chanel
END SUB

SUB SetReg (Reg, Value)
        OUT RegAddr, Reg
        OUT DataAddr, Value
END SUB

DEFSNG A-Z
SUB Stop.Sound
                SetReg &HB0 + 0, 0 'Switch channel off
                SetReg &HB0 + 1, 0 'Switch channel off
                SetReg &HB0 + 2, 0 'Switch channel off
END SUB

